type Descriptor = {
    name: string;
    text: string;
};
type DataFrame = {
    columns: string[];
    rows: any[][];
};
interface Aggregator {
    (props: string[]): (data: any[], rowKeys?: any[], colKeys?: any[]) => any;
}
interface Formatter {
    (val: any): any;
}
type TableOpts = {
    data: DataFrame;
    columns: Descriptor[];
    rows: Descriptor[];
    aggregator?: Aggregator;
    formatter?: Formatter;
    rowTotal?: boolean;
    colTotal?: boolean;
    rowTotalText?: string;
    colTotalText?: string;
};
interface h {
    (tag: string, props?: Record<string, any>, children?: Array<string | HTMLElement>): HTMLElement;
}
declare class Table {
    data: DataFrame;
    columns: Descriptor[];
    rows: Descriptor[];
    aggregator: Aggregator;
    formatter: Formatter;
    rowTotal: boolean;
    colTotal: boolean;
    rowTotalText: string;
    colTotalText: string;
    /**
     *
     */
    constructor(opts: TableOpts);
    _transform(): {
        matrix: any;
        allRowKeys: any[][];
        allColKeys: any[][];
        rowSpans: any[][];
        colSpans: any[][];
        records: any[];
    };
    _aggrateRow(records: any[], rowKeys: any[]): any;
    _aggrateCol(records: any[], colKeys: any[]): any;
    _aggrateAll(records: any[]): any;
    _renderHeader(h: h, colSpans: any[]): HTMLElement;
    _renderBody(h: h, matrix: any, allRowKeys: any[][], allColKeys: any[][], rowSpans: any[], records: any[]): HTMLElement;
    render(h: h): HTMLElement;
}
export { Table };
